//#define Profile_Recache_Sets
/*

 ScreenL.S
 Screen rendering code
 -BGMODE specific handlers, including specialized handlers for:
   layer palettes in Mode 0;
   partial offset change in Mode 2;
 -Basic BG scanline renderers;
 -Line offset in tile tables.

*/

//#define NO_OFFSET_CHANGE
//#define NO_OFFSET_CHANGE_DISABLE
//#define NO_16x16_TILES

#include "misc.i"
#include "spriteL.i"
#include "PPU.i"
#include "screen.i"

EXPORT_C screenL_start

.data
ALIGND
.globl Tile_Offset_Table_64_8
Tile_Offset_Table_64_8:
    .long   0
    .long   1*8
    .long   2*8
    .long   3*8
    .long   4*8
    .long   5*8
    .long   6*8
    .long   7*8
    .long   16*64
    .long   16*64+1*8
    .long   16*64+2*8
    .long   16*64+3*8
    .long   16*64+4*8
    .long   16*64+5*8
    .long   16*64+6*8
    .long   16*64+7*8
    .long   16*64*2
    .long   16*64*2+1*8
    .long   16*64*2+2*8
    .long   16*64*2+3*8
    .long   16*64*2+4*8
    .long   16*64*2+5*8
    .long   16*64*2+6*8
    .long   16*64*2+7*8
    .long   16*64*3
    .long   16*64*3+1*8
    .long   16*64*3+2*8
    .long   16*64*3+3*8
    .long   16*64*3+4*8
    .long   16*64*3+5*8
    .long   16*64*3+6*8
    .long   16*64*3+7*8
    .long   16*64*4
    .long   16*64*4+1*8
    .long   16*64*4+2*8
    .long   16*64*4+3*8
    .long   16*64*4+4*8
    .long   16*64*4+5*8
    .long   16*64*4+6*8
    .long   16*64*4+7*8
    .long   16*64*5
    .long   16*64*5+1*8
    .long   16*64*5+2*8
    .long   16*64*5+3*8
    .long   16*64*5+4*8
    .long   16*64*5+5*8
    .long   16*64*5+6*8
    .long   16*64*5+7*8
    .long   16*64*6
    .long   16*64*6+1*8
    .long   16*64*6+2*8
    .long   16*64*6+3*8
    .long   16*64*6+4*8
    .long   16*64*6+5*8
    .long   16*64*6+6*8
    .long   16*64*6+7*8
    .long   16*64*7
    .long   16*64*7+1*8
    .long   16*64*7+2*8
    .long   16*64*7+3*8
    .long   16*64*7+4*8
    .long   16*64*7+5*8
    .long   16*64*7+6*8
    .long   16*64*7+7*8

.globl Screen_Mode
Screen_Mode:
    .long   SCREEN_MODE_0
    .long   SCREEN_MODE_1
    .long   SCREEN_MODE_2
    .long   SCREEN_MODE_3
    .long   SCREEN_MODE_4
    .long   SCREEN_MODE_5
    .long   SCREEN_MODE_6
    .long   SCREEN_MODE_7

Screen_Mode_Table_0_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M0_P1_S     // Plane 1
    .long   M0_P2_S     // Plane 2
    .long   M0_P12_S    // Planes 1,2
    .long   M0_P3_S     // Plane 3
    .long   M0_P13_S    // Planes 1,3
    .long   M0_P23_S    // Planes 2,3
    .long   M0_P123_S   // Planes 1,2,3
    .long   M0_P4_S     // Plane 4
    .long   M0_P14_S    // Planes 1,4
    .long   M0_P24_S    // Planes 2,4
    .long   M0_P124_S   // Planes 1,2,4
    .long   M0_P34_S    // Planes 3,4
    .long   M0_P134_S   // Planes 1,3,4
    .long   M0_P234_S   // Planes 2,3,4
    .long   M0_P1234_S  // Planes 1,2,3,4
Screen_Mode_Table_0:
    .long   NO_PLANES   // This is the same for all modes
    .long   M0_P1       // Plane 1
    .long   M0_P2       // Plane 2
    .long   M0_P12      // Planes 1,2
    .long   M0_P3       // Plane 3
    .long   M0_P13      // Planes 1,3
    .long   M0_P23      // Planes 2,3
    .long   M0_P123     // Planes 1,2,3
    .long   M0_P4       // Plane 4
    .long   M0_P14      // Planes 1,4
    .long   M0_P24      // Planes 2,4
    .long   M0_P124     // Planes 1,2,4
    .long   M0_P34      // Planes 3,4
    .long   M0_P134     // Planes 1,3,4
    .long   M0_P234     // Planes 2,3,4
    .long   M0_P1234    // Planes 1,2,3,4

Screen_Mode_Table_1:
    .long   NO_PLANES   // This is the same for all modes
    .long   M1_P1       // Plane 1
    .long   M1_P2       // Plane 2
    .long   M1_P12      // Planes 1,2
    .long   M1_P3       // Plane 3
    .long   M1_P13      // Planes 1,3
    .long   M1_P23      // Planes 2,3
    .long   M1_P123     // Planes 1,2,3

Screen_Mode_Table_1_3:
    .long   NO_PLANES   // This is the same for all modes
    .long   M1_P1       // Plane 1
    .long   M1_P2       // Plane 2
    .long   M1_P12      // Planes 1,2
    .long   M1_P3_3     // Plane 3
    .long   M1_P13_3    // Planes 1,3
    .long   M1_P23_3    // Planes 2,3
    .long   M1_P123_3   // Planes 1,2,3

Screen_Mode_Table_2:
    .long   NO_PLANES   // This is the same for all modes
    .long   M2_P1       // Plane 1
    .long   M2_P2       // Plane 2
    .long   M2_P12      // Planes 1,2

Screen_Mode_Table_2_OC:
    .long   NO_PLANES   // This is the same for all modes
    .long   M2_P1_OC    // Plane 1
    .long   M2_P2_OC    // Plane 2
    .long   M2_P12_OC   // Planes 1,2

Screen_Mode_Table_3:
    .long   NO_PLANES   // This is the same for all modes
    .long   M3_P1       // Plane 1
    .long   M3_P2       // Plane 2
    .long   M3_P12      // Planes 1,2

Screen_Mode_Table_4:
    .long   NO_PLANES   // This is the same for all modes
    .long   M4_P1       // Plane 1
    .long   M4_P2       // Plane 2
    .long   M4_P12      // Planes 1,2

Screen_Mode_Table_5:
    .long   NO_PLANES   // This is the same for all modes
    .long   M5_P1       // Plane 1
    .long   M5_P2       // Plane 2
    .long   M5_P12      // Planes 1,2

Screen_Mode_Table_6:
    .long   NO_PLANES   // This is the same for all modes
    .long   M6_P1       // Plane 1 only

Screen_Mode_Table_1_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M1_P1_S     // Plane 1
    .long   M1_P2_S     // Plane 2
    .long   M1_P12_S    // Planes 1,2
    .long   M1_P3_S     // Plane 3
    .long   M1_P13_S    // Planes 1,3
    .long   M1_P23_S    // Planes 2,3
    .long   M1_P123_S   // Planes 1,2,3

Screen_Mode_Table_1_3_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M1_P1_S     // Plane 1
    .long   M1_P2_S     // Plane 2
    .long   M1_P12_S    // Planes 1,2
    .long   M1_P3_S     // Plane 3
    .long   M1_P13_3_S  // Planes 1,3
    .long   M1_P23_3_S  // Planes 2,3
    .long   M1_P123_3_S // Planes 1,2,3

Screen_Mode_Table_2_OC_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M2_P1_OC_S  // Plane 1
    .long   M2_P2_OC_S  // Plane 2
    .long   M2_P12_OC_S // Planes 1,2

Screen_Mode_Table_2_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M2_P1_S     // Plane 1
    .long   M2_P2_S     // Plane 2
    .long   M2_P12_S    // Planes 1,2

Screen_Mode_Table_3_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M3_P1_S     // Plane 1
    .long   M3_P2_S     // Plane 2
    .long   M3_P12_S    // Planes 1,2

Screen_Mode_Table_4_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M4_P1_S     // Plane 1
    .long   M4_P2_S     // Plane 2
    .long   M4_P12_S    // Planes 1,2

Screen_Mode_Table_5_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M5_P1_S     // Plane 1
    .long   M5_P2_S     // Plane 2
    .long   M5_P12_S    // Planes 1,2

Screen_Mode_Table_6_S:
    .long   NO_PLANES_S // This is the same for all modes
    .long   M6_P1_S     // Plane 1 only

ALIGND
Pixel_Increment:    .long   1,-1
First_Pixel:        .long   0,7

.bss
ALIGND
.globl LineAddress,LineAddressY,TileOffset,TileOffsetY,TileMask
LineAddress:    skipl   // Address of tileset, + offset to line in tile
LineAddressY:   skipl   // Same, for vertical flip
TileMask:       skipl   // Tile address mask, for tileset wrap
LMapAddress_Current:skipl   // Tilemap address of current left window
RMapAddress_Current:skipl   // Tilemap address of current right window
SetAddress_Current: skipl
.globl Render_Mode
Render_Mode:    skipl   // Mode renderer

Tile_priority_opcode:   skipb

.text
ALIGNC
.globl Sync_Render
Sync_Render:
  pushl %eax
  pushl %ebx
  pushl %ecx
  pushl %edx
  pushl %ebp
  pushl %esi
  pushl %edi

  movl Tile_Recache_Set_End,%edi
  incl %edi
  js  0f  // No set to recache?
  subl Tile_Recache_Set_Begin,%edi
#ifdef Profile_Recache_Sets
  addl %edi,Tiles_Recached
#endif
  call Recache_Tile_Set
#ifdef Profile_Recache_Sets
    incl Sets_Recached
#endif
  movl $-2,Tile_Recache_Set_Begin
  movl $-2,Tile_Recache_Set_End
0:

  movl ScreenDestPtr,%edi
9:xorl %eax,%eax
  movl $256/32,%ebp
  incl Current_Line_Render

ALIGNC
0:leal 16(%edi),%esi
  movl %eax,(%edi)
  movl %eax,4(%edi)
  movl %eax,8(%edi)
  movl %eax,12(%edi)
  movl %eax,(%esi)
  leal 16(%esi),%edi
  movl %eax,4(%esi)
  movl %eax,8(%esi)
  movl %eax,12(%esi)
  decl %ebp
  jnz 0b

  movb _INIDISP,%ah
  testb %ah,%ah       // Check for screen off
  jns 1f

  addl $128,%edi      // Point screen to next line
  jmp 2f

1:movb SCR_TM,%bl     // Get BG status for main screens
  call *Render_Mode
  movb SCR_TS,%bl     // Get BG status for sub screens
  call *Render_Mode
  movl ScreenDestPtr,%edi
  addl $256+128,%edi  // Point screen to next line
2:decl (%esp)
  movl %edi,ScreenDestPtr
  jnz 9b
  popl %edi
  popl %esi
  popl %ebp
  popl %edx
  popl %ecx
  popl %ebx
  popl %eax
  ret

// ~142 bytes
.macro Recalc_Window_Bands Left,Right,ICount,IBands,OCount,OBands
    movb \Left,%al
    movb \Right,%dl
    cmpb %al,%dl
    jb 1f           // if (Right < Left) full range outside window;
    movb %al,\IBands
    movb %dl,\IBands+1
    movb $1,\ICount // One band inside window (left,right)
    testb %al,%al
    jnz 2f          // if (!Left) window flush left;
    cmpb $255,%dl
    jne 3f          // if (!Left && Right == 255) full range inside;
    // Full range inside window
    movb $0,\OCount         // No bands outside window
    jmp 0f
2:  // Window not flush left (1 inside, 1 or 2 outside)
    cmpb $255,%dl
    je  3f          // if (Left && Right == 255) window flush right;
    // Window not flush left or right (1 inside, 2 outside)
    // Inside range is (left,right)
    // Outside range 1 is (0,left-1)
    // Outside range 2 is (right+1,255)
    decl %eax               // Right outside edge 1 = Left inside edge - 1
    incl %edx               // Left outside edge 2 = right inside edge + 1
    movb $2,\OCount         // One band outside window (right+1,left-1)
    movb %al,\OBands+1
    movb $0,\OBands
    movb %dl,\OBands+2
    movb $0xFF,\OBands+3
    jmp 0f
3:  // Window flush left, not flush right (1 inside, 1 outside)
    // Window flush right, not flush left (1 inside, 1 outside)
    // Inside range is (left,right), outside range is (right+1,left-1)
    decl %eax               // Right outside edge = Left inside edge - 1
    incl %edx               // Left outside edge = right inside edge + 1
    movb %al,\OBands+1
    movb $1,\OCount         // One band outside window (right+1,left-1)
    movb %dl,\OBands
    jmp 0f
1:  // Full range outside window (0 inside, 1 outside)
    movb $1,\OCount         // One band outside window
    movl $0xFF00,\OBands    // Full range band
    movb $0,\ICount         // No bands inside window
0:
.endm

ALIGNC
.globl Recalc_Window_Effects
Recalc_Window_Effects:
    pushl %eax
    pushl %edx
    Recalc_Window_Bands \
     _WH0, _WH1,\
     Win1_Count_In, Win1_Bands_In,\
     Win1_Count_Out, Win1_Bands_Out
    Recalc_Window_Bands \
     _WH2, _WH3,\
     Win2_Count_In, Win2_Bands_In,\
     Win2_Count_Out, Win2_Bands_Out
    popl %edx
    popl %eax
    ret

// esi is screen address, works cos we only plot until wraparound!
// ch contains the X counter
// cl contains the screen addition for palette offsetting (2bpl only)
// edi is the address to draw to..
// LineAddress contains the location for the SNES tile data
// LineAddress(Y) must be offset to the correct line for that row
// LineAddressY is used for Y-flip

/*
 Mode 2 is a special snes mode - It is known as [an] offset change mode,
  basically the snes has the ability to change the horizontal and/or
  vertical offset of each column on the screen, a pig to emulate but
  here is the information:

  BG1 & BG2 are 16 colour planes (this much was simple to find out)
  BG3 - This does not exist but its address in VRAM is very important!

  What happens is the horizontal and verticle information is written to
  BG2 address's BG2+0 -  BG2+63, this gives 128 bytes (since VRAM is a
  word addressed system). BG2+0 -  BG2+31 is the address for changing
  the horizontal value BG2+32 - BG2+63 is the address for changing the
  vertical value

  There are 32 values per BG mode since there are 32 tiles horizontally across the screen! My
  best guess is this value is immune to scrolling (otherwise it would make more sense to
  give a 64 tile range in case of extra width modes).

  Ok, the only other thing you need to know is what do the values at address BG2+x do.

  Well its the same for horiz as vertical the values are encoded as :

  00           | 01          | 02           | 03          |.......| 62            | 63
  col 0 offset | col 0 flags | col 1 offset | col 1 flags |.......| col 31 offset | col 31 flags

  The flags as far as I can tell are :

   bit 7 6 5 4 3 2 1 0
       ? y x ? ? ? ? ?		where	y = affect bg1
    				x = affect bg0

    			The above information came from me Savoury SnaX

Addendum by TRAC (0.33 -> 0.34)
 Mode 2/4/6 have offset change support.
 Offset change info is always stored in third layer?
 Offset change info is stored one word per (8 pixel) tile, which appears
  to have the format of:

  FEDCBA9786543210
  x21xxxoooooooooo

  x = unused?
  o = offset
  1 = enable for first layer
  2 = enable for second layer

 third layer scroll affects location of offset change map

*/

ALIGNC
// Note: Buggy, will be rewritten when I get around to it
RENDER_LINE_M2_8x8:
    // %ch contains bit for determining planes to affect
    movl VScroll(%edx),%eax
    movl %eax,VScroll_8x8_M2
    movl TLMapAddress(%edx),%eax
    movl %eax,TMapAddress_8x8_M2
    movl BLMapAddress(%edx),%eax
    movl %eax,BMapAddress_8x8_M2
    xorl %esi,%esi

    movl HScroll_3,%eax
    movl VScroll_3,%edi
    shrl $2,%eax
    shll $2,%edi
    andl $(0x1F << 1),%eax
    andl $(0x1F << 5),%edi

    movl MapAddressBG3,%ebx // %ebx contains address of vert offset data
    addl %edi,%ebx          // BG3VOFS adjusted
    addl $31*2,%ebx         // Vertical offset change map
    movl ScreenDestPtr,%edi
    movl %ebx,MapAddress_OffsetChange
    movl %eax,%ebx

    pushl %ebx
    movl Current_Line_Render,%eax
    pushl %ecx
    jmp 0f

2:  pushl %ebx
    addl $0x80000000,%ebx
MapAddress_OffsetChange=.-4
    movl Current_Line_Render,%eax
    pushl %ecx
    movb 1(%ebx),%dh
    andb %dh,%ch
    jz  0f
    movb (%ebx),%dl
    addl %edx,%eax
    jmp 1f

0:  addl $0x80000000,%eax
VScroll_8x8_M2=.-4

1:
    testb $1,%ah
    movl $0x80000000,%ebp
BMapAddress_8x8_M2=.-4
    jnz 0f
    movl $0x80000000,%ebp
TMapAddress_8x8_M2=.-4
0:

    // al contains real Y offset for next tile
    shll $3,%eax        // Get screen offset
    movl $0xF8*8,%ecx
    andl %eax,%ecx
    movl $8*7,%ebx
    addl %ebp,%ecx
    andl $0x07*8,%eax
    addl %esi,%ecx      // Combine X and Y offsets into tile map
    subl %eax,%ebx
    movl %eax,LineAddress
    addl $2,%esi        // Update X offset
    movl %ebx,LineAddressY
    andl $31*2,%esi     // X offset wrap

    movb 1(%ecx),%al
    pushl %esi
    movl (%ecx),%esi    // Get tile information
    movb %al,%dh
    andb $0x1C,%dh      // Get palette
    shlb $2,%dh

    movl %esi,%ebp      // Get flip flags
    orb  $0x0F,%dh
    shll $6,%esi        // 8*8
//  movb %dh,ColourBase

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl SetAddress_Current,%esi

    addl _TileCache4,%esi
    call Tile_Line_8_4(%ebp)
    addl $8,%edi

    popl %esi
    popl %ecx
    popl %ebx

    addl $2,%ebx
    andl $31*2,%ebx
    decb %cl
    jnz 2b

    ret

.macro Plot_8_PaletteMask
    movb ColourBase,%dl
//  movl $8,%ebp
    movl $2,%ebp
3:  movl (%esi),%eax
    addl $4,%esi
    andb %dl,%al
    jz  4f
    movb %al,(%edi)
4:  addl %ebx,%edi
//  decl %ebp
//  jz  3f
    andb %dl,%ah
    jz  4f
    movb %ah,(%edi)
4:  addl %ebx,%edi
//  decl %ebp
//  jz  3f
    shrl $16,%eax
    andb %dl,%al
    jz  4f
    movb %al,(%edi)
4:  addl %ebx,%edi
//  decl %ebp
//  jz  3f
    andb %dl,%ah
    jz  4f
    movb %ah,(%edi)
4:  addl %ebx,%edi
    decl %ebp
    jnz 3b
3:
.endm

// New for v0.15, Mode 0 has its own renderers
ALIGNC
LINE_8x8_M0:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L8x8_priority_M0:       // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    movl (%ebx),%esi    // Get tile information
    andb $0x1C,%al      // Get palette
    movl %esi,%ebp      // Get flip flags
    orb  %cl,%al        // Adjust palette for mode 0
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_8x8_M0=.-4

    addl _TileCache2,%esi
    call Tile_Line_8_2(%ebp)

2:  addl $8,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

ALIGNC
// Relies on H-scroll, tile size, tilemap size
.globl RENDER_M0_8x8
RENDER_M0_8x8:
    movb Tile_priority_opcode,%al
    movb %al,L8x8_priority_M0
    SORT_TILES_8_TALL   // This sets up the screen vert 2!
    movl ScreenDestPtr,%edi
    movl SetAddress(%edx),%eax
    movl %eax,SetAddress_8x8_M0

    movb TileCount1(%edx),%ch
    pushl %ebx
    movb TileCount2(%edx),%ah
    pushl %edx
    pushl %eax
    addl VLMapAddress(%edx),%ebx
    subl FirstPixel(%edx),%edi
    call LINE_8x8_M0
    movb 1(%esp),%ch
    popl %esi
    popl %edx
    testb %ch,%ch
    popl %ebx
    jz  0f
    addl VRMapAddress(%edx),%ebx
//  call LINE_8x8_M0
    jmp LINE_8x8_M0
0:  ret

ALIGNC
LINE_16x16_M0:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L16x16_priority_M0:     // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    movl (%ebx),%esi    // Get tile information
    andb $0x1C,%al      // Get palette
    movl %esi,%ebp      // Get flip flags
    orb  %cl,%al        // Adjust palette for mode 0
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_16x16_M0=.-4

    addl _TileCache2,%esi
    call Tile_Line_16_2(%ebp)

2:  addl $16,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

ALIGNC
.globl RENDER_M0_16x16
RENDER_M0_16x16:
    movb Tile_priority_opcode,%al
    movb %al,L16x16_priority_M0
    SORT_TILES_16_TALL  // This sets up the screen vert 2!
    movl ScreenDestPtr,%edi
    movl SetAddress(%edx),%eax
    movl %eax,SetAddress_16x16_M0

    movb TileCount1(%edx),%ch
    pushl %ebx
    movb TileCount2(%edx),%ah
    pushl %edx
    pushl %eax
    addl VLMapAddress(%edx),%ebx
    subl FirstPixel(%edx),%edi
    call LINE_16x16_M0
    movb 1(%esp),%ch
    popl %esi
    popl %edx
    testb %ch,%ch
    popl %ebx
    jz  0f
    addl VRMapAddress(%edx),%ebx
//  call LINE_16x16_M0
    jmp LINE_16x16_M0
0:  ret

ALIGNC
LINE_8x8_C2:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L8x8_priority_C2:       // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    movl (%ebx),%esi    // Get tile information
    andb $0x1C,%al      // Get palette
    movl %esi,%ebp      // Get flip flags
    orb  $3,%al
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_8x8_C2=.-4

    addl _TileCache2,%esi
    call Tile_Line_8_2(%ebp)

2:  addl $8,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

ALIGNC
LINE_8x8_C4:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L8x8_priority_C4:       // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    andb $0x1C,%al      // Get palette
    shlb $2,%al
    movl (%ebx),%esi    // Get tile information
    orb  $0x0F,%al
    movl %esi,%ebp
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_8x8_C4=.-4

    addl _TileCache4,%esi
    call Tile_Line_8_4(%ebp)

2:  addl $8,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

ALIGNC
LINE_8x8_C8:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L8x8_priority_C8:       // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    movl (%ebx),%esi    // Get tile information
    movl %esi,%ebp      // Get flip flags
    shll $6,%esi        // 8*8

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_8x8_C8=.-4

    addl _TileCache8,%esi
    call Tile_Line_8_8(%ebp)

2:  addl $8,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

.macro RENDER_8x8 depth
    movb Tile_priority_opcode,%al
    movb %al,L8x8_priority_C\depth
    SORT_TILES_8_TALL   // This sets up the screen vert 2!
    movl ScreenDestPtr,%edi
    movl SetAddress(%edx),%eax
    movl %eax,SetAddress_8x8_C\depth

    movb TileCount1(%edx),%ch
    pushl %ebx
    movb TileCount2(%edx),%ah
    pushl %edx
    pushl %eax
    addl VLMapAddress(%edx),%ebx
    subl FirstPixel(%edx),%edi
    call LINE_8x8_C\depth
    movb 1(%esp),%ch
    popl %esi
    popl %edx
    testb %ch,%ch
    popl %ebx
    jz  0f
    addl VRMapAddress(%edx),%ebx
//  call LINE_8x8_C\depth
    jmp LINE_8x8_C\depth
0:  ret
.endm

ALIGNC
LINE_16_Even_C2:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L16_Even_priority_C2:   // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    movl (%ebx),%esi    // Get tile information
    andb $0x1C,%al      // Get palette
    movl %esi,%ebp      // Get flip flags
    orb  $3,%al
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_16_Even_C2=.-4

    addl _TileCache2,%esi
    call Tile_Line_16_2_Even(%ebp)

2:  addl $8,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

ALIGNC
LINE_16_Even_C4:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L16_Even_priority_C4:   // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    andb $0x1C,%al      // Get palette
    shlb $2,%al
    movl (%ebx),%esi    // Get tile information
    orb  $0x0F,%al
    movl %esi,%ebp      // Get flip flags
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_16_Even_C4=.-4

    addl _TileCache4,%esi
    call Tile_Line_16_4_Even(%ebp)

2:  addl $8,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

.macro RENDER_16_Even depth
    movl ScreenDestPtr,%edi
    movl SetAddress(%edx),%eax
    movl %eax,SetAddress_16_Even_C\depth

    movb TileCount1(%edx),%ch
    pushl %ebx
    movb TileCount2(%edx),%ah
    pushl %edx
    pushl %eax
    addl VLMapAddress(%edx),%ebx
    subl FirstPixel(%edx),%edi
    call LINE_16_Even_C\depth
    movb 1(%esp),%ch
    popl %esi
    popl %edx
    testb %ch,%ch
    popl %ebx
    jz  0f
    addl VRMapAddress(%edx),%ebx
//  call LINE_16_Even_C\depth
    jmp LINE_16_Even_C\depth
0:  ret
.endm

ALIGNC
LINE_16x16_C2:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L16x16_priority_C2:     // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    movl (%ebx),%esi    // Get tile information
    andb $0x1C,%al      // Get palette
    movl %esi,%ebp      // Get flip flags
    orb  $3,%al
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_16x16_C2=.-4

    addl _TileCache2,%esi
    call Tile_Line_16_2(%ebp)

2:  addl $16,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

ALIGNC
LINE_16x16_C4:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L16x16_priority_C4:     // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    andb $0x1C,%al      // Get palette
    shlb $2,%al
    movl (%ebx),%esi    // Get tile information
    orb  $0x0F,%al
    movl %esi,%ebp      // Get flip flags
    shll $6,%esi        // 8*8
//  movb %al,ColourBase
    movb %al,%dh

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_16x16_C4=.-4

    addl _TileCache4,%esi
    call Tile_Line_16_4(%ebp)

2:  addl $16,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

ALIGNC
LINE_16x16_C8:
1:  movb 1(%ebx),%al
    testb $0x20,%al     // Check tile priority
L16x16_priority_C8:     // If pri is 1, jz should be here!
    jz  2f              // dummy jump

    movl (%ebx),%esi    // Get tile information
    movl %esi,%ebp      // Get flip flags
    shll $6,%esi        // 8*8

    shrl $12,%ebp
    movl LineAddressY,%eax
    testl $8,%ebp       // Check Y flip
    jnz 3f
    movl LineAddress,%eax
3:  addl %eax,%esi
    andl $4,%ebp        // Get X flip
    andl $0x3FF*64+8*7,%esi    // Get tile # with tileset wrap
    addl $0x80000000,%esi
SetAddress_16x16_C8=.-4

    addl _TileCache8,%esi
    call Tile_Line_16_8(%ebp)

2:  addl $16,%edi
    addl $2,%ebx        // Update screen pointer
    decb %ch
    jnz 1b
    ret

.macro RENDER_16x16 depth
    movb Tile_priority_opcode,%al
    movb %al,L16x16_priority_C\depth
    SORT_TILES_16_TALL  // This sets up the screen vert 2!
    movl ScreenDestPtr,%edi
    movl SetAddress(%edx),%eax
    movl %eax,SetAddress_16x16_C\depth

    movb TileCount1(%edx),%ch
    pushl %ebx
    movb TileCount2(%edx),%ah
    pushl %edx
    pushl %eax
    addl VLMapAddress(%edx),%ebx
    subl FirstPixel(%edx),%edi
    call LINE_16x16_C\depth
    movb 1(%esp),%ch
    popl %esi
    popl %edx
    testb %ch,%ch
    popl %ebx
    jz  0f
    addl VRMapAddress(%edx),%ebx
//  call LINE_16x16_C\depth
    jmp LINE_16x16_C\depth
0:  ret
.endm

.globl RENDER_8x8_C2,RENDER_16x16_C2,RENDER_16x8_Even_C2,RENDER_16x16_Even_C2
.globl RENDER_8x8_C4,RENDER_16x16_C4,RENDER_16x8_Even_C4,RENDER_16x16_Even_C4
.globl RENDER_8x8_C8,RENDER_16x16_C8
ALIGNC
RENDER_8x8_C2:
    RENDER_8x8 2
ALIGNC
RENDER_16x16_C2:
#ifdef NO_16x16_TILES
    ret
#endif // NO_16x16_TILES
    RENDER_16x16 2
ALIGNC
RENDER_16x8_Even_C2:
    SORT_TILES_8_TALL   // This sets up the screen vert 2!
    RENDER_16_Even 2
ALIGNC
RENDER_16x16_Even_C2:
#ifdef NO_16x16_TILES
    ret
#endif // NO_16x16_TILES
    SORT_TILES_16_TALL  // This sets up the screen vert 2!
    RENDER_16_Even 2
ALIGNC
RENDER_8x8_C4:
    RENDER_8x8 4
ALIGNC
RENDER_16x16_C4:
#ifdef NO_16x16_TILES
    ret
#endif // NO_16x16_TILES
    RENDER_16x16 4
ALIGNC
RENDER_16x8_Even_C4:
    SORT_TILES_8_TALL   // This sets up the screen vert 2!
    RENDER_16_Even 4
ALIGNC
RENDER_16x16_Even_C4:
#ifdef NO_16x16_TILES
    ret
#endif // NO_16x16_TILES
    SORT_TILES_16_TALL  // This sets up the screen vert 2!
    RENDER_16_Even 4
ALIGNC
RENDER_8x8_C8:
    RENDER_8x8 8
ALIGNC
RENDER_16x16_C8:
#ifdef NO_16x16_TILES
    ret
#endif // NO_16x16_TILES
    RENDER_16x16 8

.macro SORT_SCREEN_LAYOUT num
    movb Redo_BGs,%ah
    LOAD_BG_TABLE \num
    testb $1<<(\num-1),%ah
    jz  0f

    call BG_Redo(%edx)

0:
    movb TileHeight(%edx),%al
    movb TileWidth(%edx),%cl
    movb %al,Tile_Height
    movb %cl,Tile_Width
    call Sort_Screen_Height
.endm

ALIGNC
Sort_Screen_Height:
    // Corrupts eax,ecx,ebp
    movb HScroll+1(%edx),%al
    movl $TLMapAddress,%ecx
    testb $1,%al
.globl Tile_Width
Tile_Width=.-1     // 1 = 8x8, 2 = 16x8, 16x16
    movl $TRMapAddress,%ebp
    jz  0f
    addl $(TRMapAddress-TLMapAddress),%ecx
    addl $(TLMapAddress-TRMapAddress),%ebp
0:  movb Mosaic(%edx),%al
    testb %al,%al
    movl Current_Line_Render,%eax
    jz  0f
    movl Current_Line_Mosaic,%eax
0:  addl VScroll(%edx),%eax
    testb $1,%ah
.globl Tile_Height
Tile_Height=.-1     // 1 = 8x8, 16x8, 2 = 16x16
    jz  0f
    addl $(BLMapAddress-TLMapAddress),%ecx
    addl $(BLMapAddress-TLMapAddress),%ebp
0:  movl (%edx,%ecx),%eax
    addl FirstTile(%edx),%eax
    movl %eax,VLMapAddress(%edx)
    movl (%edx,%ebp),%eax
    movl %eax,VRMapAddress(%edx)
    ret

ALIGNC
.globl NO_PLANES
NO_PLANES:
    ALL_SPRITES_PLANE 0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 3
NO_PLANES_S:
    ret

// v0.15 - Mode 0 has it's own renderer, %cl is palette offset for bkg layer
.macro RENDER_LINE_M0 planenum,pri,setpal=-1
.if \setpal-0
  movb $(((\planenum)-1)<<5)+3,%cl  // Palette offset
.endif
  LOAD_BG_TABLE \planenum
  movb $0x75-\pri,Tile_priority_opcode
  call LineRender(%edx) // tile size (8x8/16x16) selected in BGMODE
.endm

.macro RENDER_LINE planenum,depth,pri
  LOAD_BG_TABLE \planenum
  movb $0x75-\pri,Tile_priority_opcode
  call LineRender(%edx) // tile size (8x8/16x16) selected in BGMODE
.endm

// v0.25 - Modes 5 & 6 better supported...

.macro RENDER_LINE_M5_M6 planenum,depth,pri
  LOAD_BG_TABLE \planenum
  movb $0x75-\pri,L16_Even_priority_C\depth
  call LineRender(%edx) // tile size (16x8/16x16) selected in BGMODE
.endm

// v0.15 - New for rendering offset change in mode 2
.macro RENDER_LINE_M2 planenum,depth
    LOAD_BG_TABLE \planenum

    // Hack to allow vertical mosaic until offset change code supports it
    // Begin vertical mosaic mode 2 hack part 1
    movl Current_Line_Render,%eax
    pushl %eax
    movb Mosaic(%edx),%al
    testb %al,%al
    jz  0f
    movl Current_Line_Mosaic,%eax
    movl %eax,Current_Line_Render
0:  // End vertical mosaic mode 2 hack part 1
    movl SetAddressBG\planenum,%eax
    movl %eax,SetAddress_Current
    movb $1<<((\planenum)+4),%ch
    movb _BGMODE,%al
    testb $(1<<(\planenum+3)),%al
    jnz 8f          /* If set 16x16 tiles */

    movl MapAddressBG\planenum,%esi
    movb $0x20,%cl      // Count of tiles to render
    call RENDER_LINE_M2_8x8
    jmp 7f
8:              /* 16x16 tiles */
/*
    addl LMapAddress_Current,%esi
    call RENDER_LINE_M2_16x16*/
7:
    // Begin vertical mosaic mode 2 hack part 2
    popl %eax
    movl %eax,Current_Line_Render
    // End vertical mosaic mode 2 hack part 2
.endm

/* Mode 0 - 4 background layers, 8x8 and 16x16 tile sizes
 *  2bpl tile depth in all layers
 *  special: BG3 high priority selection
 *           each background layer has its own set of palettes
 */
ALIGNC
.globl SCREEN_MODE_0
SCREEN_MODE_0:  // There are 15 Versions of Render & Merge functions (4 planes)

    CALCULATE_MOSAIC_YLINE 0x0F

    pushl %ebx
    SORT_SCREEN_LAYOUT 1
    SORT_SCREEN_LAYOUT 2
    SORT_SCREEN_LAYOUT 3
    SORT_SCREEN_LAYOUT 4
    popl %ebx
    movb $0,Redo_BGs

    movb Redo_OAM,%al
    testb %al,%al
    jz 0f
    pushl %ebx
    pusha
    call Recache_OAM
    popa
    popl %ebx
0:  andl $0x1F,%ebx
    jmp Screen_Mode_Table_0_S(,%ebx,4)

ALIGNC
M0_P1:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret

ALIGNC
M0_P1_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 1,0,0
    ret

ALIGNC
M0_P2:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret

ALIGNC
M0_P12:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret

ALIGNC
M0_P12_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    ret

ALIGNC
M0_P2_S:
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 2,0,0
    ret

ALIGNC
M0_P3:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    ret

ALIGNC
M0_P13:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    ret

ALIGNC
M0_P13_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 1,0,0
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 3,0,0
    ret

ALIGNC
M0_P23:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    ret

ALIGNC
M0_P123:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    ret

ALIGNC
M0_P123_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 3,0,0
    ret

ALIGNC
M0_P23_S:
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 2,0,0
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 3,0,0
    ret

ALIGNC
M0_P3_S:
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 3,0,0
    ret

ALIGNC
M0_P4:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P14:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P14_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 1,0,0
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 4,0,0
    ret

ALIGNC
M0_P24:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P124:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P124_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 4,0,0
    ret

ALIGNC
M0_P24_S:
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 2,0,0
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 4,0,0
    ret

ALIGNC
M0_P34:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P134:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P134_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 1,0,0
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret


ALIGNC
M0_P234:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P1234:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P1234_S:
    RENDER_LINE_M0 1,1
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 1,0
    RENDER_LINE_M0 2,0
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P234_S:
    RENDER_LINE_M0 2,1
    RENDER_LINE_M0 2,0,0
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P34_S:
    RENDER_LINE_M0 3,1
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 3,0
    RENDER_LINE_M0 4,0
    ret

ALIGNC
M0_P4_S:
    RENDER_LINE_M0 4,1
    RENDER_LINE_M0 4,0,0
    ret

/* Mode 1 - 3 background layers, 8x8 and 16x16 tile sizes
 *  4bpl tile depth in layers 1 and 2, 2bpl tile depth in layer 3
 *  special: BG3 high priority selection
 */
.globl SCREEN_MODE_1
SCREEN_MODE_1:  // There are 7 Versions of Render & Merge functions (3 planes)

    CALCULATE_MOSAIC_YLINE 0x07

    pushl %ebx
    SORT_SCREEN_LAYOUT 1
    SORT_SCREEN_LAYOUT 2
    SORT_SCREEN_LAYOUT 3
    popl %ebx
    movb $0,Redo_BGs

    movb _BGMODE,%al
    testb $0x10,%bl     // Are sprites enabled?
    jz 2f

    movb Redo_OAM,%ah
    testb %ah,%ah
    jz 0f
    pushl %eax
    pushl %ebx
    pusha
    call Recache_OAM
    popa
    popl %ebx
    popl %eax
0:  andl $7,%ebx
    testb $8,%al
    jnz 1f

    jmp Screen_Mode_Table_1(,%ebx,4)
1:  jmp Screen_Mode_Table_1_3(,%ebx,4)

ALIGNC
2:  andl $7,%ebx
    testb $8,%al
    jnz 1f

    jmp Screen_Mode_Table_1_S(,%ebx,4)
1:  jmp Screen_Mode_Table_1_3_S(,%ebx,4)

ALIGNC
M1_P1:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 1,4,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret

ALIGNC
M1_P1_S:
    RENDER_LINE 1,4,1
    RENDER_LINE 1,4,0
    ret

ALIGNC
M1_P2:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,4,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret

ALIGNC
M1_P2_S:
    RENDER_LINE 2,4,1
    RENDER_LINE 2,4,0
    ret

ALIGNC
M1_P12:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 1,4,0
    RENDER_LINE 2,4,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret

ALIGNC
M1_P12_S:
    RENDER_LINE 1,4,1
    RENDER_LINE 2,4,1
    RENDER_LINE 1,4,0
    RENDER_LINE 2,4,0
    ret

ALIGNC
M1_P3:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P3_S:
    RENDER_LINE 3,2,1
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P3_3:
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P13:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 1,4,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P13_S:
    RENDER_LINE 1,4,1
    RENDER_LINE 1,4,0
    RENDER_LINE 3,2,1
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P13_3:
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 1,4,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P13_3_S:
    RENDER_LINE 3,2,1
    RENDER_LINE 1,4,1
    RENDER_LINE 1,4,0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P23:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,4,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P23_S:
    RENDER_LINE 2,4,1
    RENDER_LINE 2,4,0
    RENDER_LINE 3,2,1
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P23_3:
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 3
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,4,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P23_3_S:
    RENDER_LINE 3,2,1
    RENDER_LINE 2,4,1
    RENDER_LINE 2,4,0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P123:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 1,4,0
    RENDER_LINE 2,4,0
    ALL_SPRITES_PLANE 1
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P123_S:
    RENDER_LINE 1,4,1
    RENDER_LINE 2,4,1
    RENDER_LINE 1,4,0
    RENDER_LINE 2,4,0
    RENDER_LINE 3,2,1
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P123_3:
    RENDER_LINE 3,2,1
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 1,4,0
    RENDER_LINE 2,4,0
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 3,2,0
    ret

ALIGNC
M1_P123_3_S:
    RENDER_LINE 3,2,1
    RENDER_LINE 1,4,1
    RENDER_LINE 2,4,1
    RENDER_LINE 1,4,0
    RENDER_LINE 2,4,0
    RENDER_LINE 3,2,0
    ret

/* Mode 2 - 2 background layers, 8x8 and 16x16 tile sizes
 *  4bpl tile depth in layers 1 and 2
 *  special: offset change data (h and v) stored in layer 3
 */
.globl SCREEN_MODE_2
SCREEN_MODE_2:  // There are 3 Versions of Render & Merge functions (2 planes)

    CALCULATE_MOSAIC_YLINE 0x03

    pushl %ebx
    SORT_SCREEN_LAYOUT 1
    SORT_SCREEN_LAYOUT 2
    popl %ebx
    movb $0,Redo_BGs

    testb $0x10,%bl     // Are sprites enabled?
    jz 1f

    movb Redo_OAM,%al
    testb %al,%al
    jz 0f
    pushl %ebx
    pusha
    call Recache_OAM
    popa
    popl %ebx
0:
    andl $3,%ebx
#ifndef NO_OFFSET_CHANGE
#ifndef NO_OFFSET_CHANGE_DISABLE
    cmpb $0,Offset_Change_Disable   // Hack to disable offset change
    jnz 0f
#endif  // !NO_OFFSET_CHANGE_DISABLE
    jmp Screen_Mode_Table_2_OC(,%ebx,4)
#ifndef NO_OFFSET_CHANGE_DISABLE
0:  jmp Screen_Mode_Table_2(,%ebx,4)
#endif  // !NO_OFFSET_CHANGE_DISABLE
#else   // NO_OFFSET_CHANGE
    jmp Screen_Mode_Table_2(,%ebx,4)
#endif

1:  andl $3,%ebx
    cmpb $0,Offset_Change_Disable   // Hack to disable offset change
    jnz 1f
    jmp Screen_Mode_Table_2_OC_S(,%ebx,4)
1:  jmp Screen_Mode_Table_2_S(,%ebx,4)

/* Specialist render function used (ignores scroll values eeek!) */

M2_P1_OC:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M2 1,4
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret
M2_P1_OC_S:
    RENDER_LINE_M2 1,4
    ret
M2_P2_OC:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M2 2,4
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret
M2_P2_OC_S:
    RENDER_LINE_M2 2,4
    ret
M2_P12_OC:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M2 1,4
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M2 2,4
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    ret
M2_P12_OC_S:
    RENDER_LINE_M2 1,4
    RENDER_LINE_M2 2,4
    ret

/* Temp - used for disabled offset-change */

M2_P1:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE 1,4,0
    ALL_SPRITES_PLANE 0
    ret
M2_P1_S:
    RENDER_LINE 1,4,1
    RENDER_LINE 1,4,0
    ret
M2_P2:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 2,4,0
    ret
M2_P2_S:
    RENDER_LINE 2,4,1
    RENDER_LINE 2,4,0
    ret
M2_P12:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 1
    RENDER_LINE 1,4,0
    ALL_SPRITES_PLANE 0
    RENDER_LINE 2,4,0
    ret
M2_P12_S:
    RENDER_LINE 1,4,1
    RENDER_LINE 2,4,1
    RENDER_LINE 1,4,0
    RENDER_LINE 2,4,0
    ret

/* Mode 3 - 2 background layers, 8x8 and 16x16 tile sizes
 *  8bpl tile depth in layer 1, 4bpl tile depth in layer 2
 *  special: direct color mode
 */
.globl SCREEN_MODE_3
SCREEN_MODE_3:  // There are 3 Versions of Render & Merge functions (2 planes)

    CALCULATE_MOSAIC_YLINE 0x03

    pushl %ebx
    SORT_SCREEN_LAYOUT 1
    SORT_SCREEN_LAYOUT 2
    popl %ebx
    movb $0,Redo_BGs

    testb $0x10,%bl     // Are sprites enabled?
    jz 1f

    movb Redo_OAM,%al
    testb %al,%al
    jz 0f
    pushl %ebx
    pusha
    call Recache_OAM
    popa
    popl %ebx
0:
    andl $3,%ebx
    jmp Screen_Mode_Table_3(,%ebx,4)

1:  andl $3,%ebx
    jmp Screen_Mode_Table_3_S(,%ebx,4)

M3_P1:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,8,1
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE 1,8,0
    ALL_SPRITES_PLANE 0
    ret
M3_P1_S:
    RENDER_LINE 1,8,1
    RENDER_LINE 1,8,0
    ret
M3_P2:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 2,4,0
    ret
M3_P2_S:
    RENDER_LINE 2,4,1
    RENDER_LINE 2,4,0
    ret
M3_P12:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,8,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,4,1
    ALL_SPRITES_PLANE 1
    RENDER_LINE 1,8,0
    ALL_SPRITES_PLANE 0
    RENDER_LINE 2,4,0
    ret
M3_P12_S:
    RENDER_LINE 1,8,1
    RENDER_LINE 2,4,1
    RENDER_LINE 1,8,0
    RENDER_LINE 2,4,0
    ret

/* Mode 4 - 2 background layers, 8x8 and 16x16 tile sizes
 *  8bpl tile depth in layer 1, 2bpl tile depth in layer 2
 *  special: direct color mode
 *           offset change data (h or v?) stored in layer 3
 */
.globl SCREEN_MODE_4
SCREEN_MODE_4:  // There are 3 Versions of Render & Merge functions (2 planes)

    CALCULATE_MOSAIC_YLINE 0x03

    pushl %ebx
    SORT_SCREEN_LAYOUT 1
    SORT_SCREEN_LAYOUT 2
    popl %ebx
    movb $0,Redo_BGs

    testb $0x10,%bl     // Are sprites enabled?
    jz 1f

    movb Redo_OAM,%al
    testb %al,%al
    jz 0f
    pushl %ebx
    pusha
    call Recache_OAM
    popa
    popl %ebx
0:
    andl $3,%ebx
    jmp Screen_Mode_Table_4(,%ebx,4)

1:  andl $3,%ebx
    jmp Screen_Mode_Table_4_S(,%ebx,4)

M4_P1:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,8,1
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE 1,8,0
    ALL_SPRITES_PLANE 0
    ret
M4_P1_S:
    RENDER_LINE 1,8,1
    RENDER_LINE 1,8,0
    ret
M4_P2:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,2,1
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE 2,2,0
    ret
M4_P2_S:
    RENDER_LINE 2,2,1
    RENDER_LINE 2,2,0
    ret
M4_P12:
    ALL_SPRITES_PLANE 3
    RENDER_LINE 1,8,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE 2,2,1
    ALL_SPRITES_PLANE 1
    RENDER_LINE 1,8,0
    ALL_SPRITES_PLANE 0
    RENDER_LINE 2,2,0
    ret
M4_P12_S:
    RENDER_LINE 1,8,1
    RENDER_LINE 2,2,1
    RENDER_LINE 1,8,0
    RENDER_LINE 2,2,0
    ret

/* Mode 5 - 2 background layers, 16x8 and 16x16 tile sizes
 *  4bpl tile depth in layer 1, 2bpl tile depth in layer 2
 *  special: 512 mode
 */
.globl SCREEN_MODE_5
SCREEN_MODE_5:  // There are 3 Versions of Render & Merge functions (2 planes)

    CALCULATE_MOSAIC_YLINE 0x03

    pushl %ebx
    SORT_SCREEN_LAYOUT 1
    SORT_SCREEN_LAYOUT 2
    popl %ebx
    movb $0,Redo_BGs

    testb $0x10,%bl     // Are sprites enabled?
    jz 1f

    movb Redo_OAM,%al
    testb %al,%al
    jz 0f
    pushl %ebx
    pusha
    call Recache_OAM
    popa
    popl %ebx
0:
    andl $3,%ebx
    jmp Screen_Mode_Table_5(,%ebx,4)

1:  andl $3,%ebx
    jmp Screen_Mode_Table_5_S(,%ebx,4)

M5_P1:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M5_M6 1,4,1
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M5_M6 1,4,0
    ALL_SPRITES_PLANE 0
    ret
M5_P1_S:
    RENDER_LINE_M5_M6 1,4,1
    RENDER_LINE_M5_M6 1,4,0
    ret
M5_P2:
    ALL_SPRITES_PLANE 3
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M5_M6 2,2,1
    ALL_SPRITES_PLANE 1
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M5_M6 2,2,0
    ret
M5_P2_S:
    RENDER_LINE_M5_M6 2,2,1
    RENDER_LINE_M5_M6 2,2,0
    ret
M5_P12:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M5_M6 1,4,1
    ALL_SPRITES_PLANE 2
    RENDER_LINE_M5_M6 2,2,1
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M5_M6 1,4,0
    ALL_SPRITES_PLANE 0
    RENDER_LINE_M5_M6 2,2,0
    ret
M5_P12_S:
    RENDER_LINE_M5_M6 1,4,1
    RENDER_LINE_M5_M6 2,2,1
    RENDER_LINE_M5_M6 1,4,0
    RENDER_LINE_M5_M6 2,2,0
    ret

/* Mode 6 - 1 background layer, 16x8 and 16x16 tile sizes
 *  4bpl tile depth in layer 1
 *  special: 512 mode
 *           offset change data (h and v?) stored in layer 3 (?)
 */
.globl SCREEN_MODE_6
SCREEN_MODE_6:  // There is 1 Versions of Render & Merge functions (1 planes)

    CALCULATE_MOSAIC_YLINE 0x01

    pushl %ebx
    SORT_SCREEN_LAYOUT 1
    popl %ebx
    movb $0,Redo_BGs

    testb $0x10,%bl     // Are sprites enabled?
    jz 1f

    movb Redo_OAM,%al
    testb %al,%al
    jz 0f
    pushl %ebx
    pusha
    call Recache_OAM
    popa
    popl %ebx
0:
    andl $1,%ebx
    jmp Screen_Mode_Table_6(,%ebx,4)

1:  andl $1,%ebx
    jmp Screen_Mode_Table_6_S(,%ebx,4)

M6_P1:
    ALL_SPRITES_PLANE 3
    RENDER_LINE_M5_M6 1,4,1
    ALL_SPRITES_PLANE 2
    ALL_SPRITES_PLANE 1
    RENDER_LINE_M5_M6 1,4,0
    ALL_SPRITES_PLANE 0
    ret
M6_P1_S:
    RENDER_LINE_M5_M6 1,4,1
    RENDER_LINE_M5_M6 1,4,0
    ret

.text; ALIGNC
.data; ALIGND
.bss; ALIGND
