#ifndef SNEeSe_SPC_i
#define SNEeSe_SPC_i

#include "regs.i"

.macro Execute_SPC SaveCycles=1
    pusha
.if \SaveCycles-0
    cmpb $0,CPU_Executing
    movl _65c816_Cycles,%eax
    jnz 9f
    movl SNES_Cycles,%eax
9:  // Update CPU and SPC cycles
    movl SPC_last_cycles,%edi
    movl %eax,SPC_last_cycles
    subl %edi,%eax
    addl SPC_CPU_cycles,%eax
.endif

    movl %eax,%ecx          // We don't want to lose cycles..
    andl $(~31),%eax
    shrl $5,%eax            // Divide by 32
    andl $31,%ecx
    leal (%eax,%eax,2),%eax // Multiply by 3
    movl %ecx,SPC_CPU_cycles
    addl SPC_Cycles,%eax    // Add new balance of SPC cycles
    movl %eax,SPC_Cycles
    cmpl %eax,_TotalCycles
    jb 8f
    /* Check for and handle 35-minute wrap */
    testl %eax,%eax
    js  9f
    cmpl $0,_TotalCycles
    jns 9f
    movl $0xF0000000,%ecx
    subl %ecx,_TotalCycles
    subl %ecx,%eax
    subl %ecx,_CycleLatch0
    movl %eax,SPC_Cycles
    subl %ecx,_CycleLatch1
    subl %ecx,_CycleLatch2
8:  call SPC_START
9:  popa
.endm

#endif /* SNEeSe_SPC_i */
